#include "paps.h"

struct ifreq ifr;
struct sockaddr_ll sa;
int sock, own_ip;
unsigned char zero_hw[ETH_ALEN], own_hw[ETH_ALEN];      
unsigned char bcast_hw[ETH_ALEN] = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };

void arp_discovery(int *first, int *last)
{
  fd_set rfd;
  pcap_t *p_arp;
  elem_t *new;
  struct pcap_pkthdr hdr;
  struct ethhdr *query_eth_h;
  struct arphdr *query_arp_h, *response_arp_h;
  struct timeval timeout;
  unsigned char packet[sizeof(struct ethhdr)+sizeof(struct arphdr)]; 
  unsigned char *pkt, errbuf[128];
  unsigned char sip[50], addr[50];
  int bottom_boundry, top_boundry;
  int count, pfd, check;
  int a, b, c, d;


  if((sock=socket(PF_PACKET, SOCK_RAW, 0))<0)
    { perror("socket: ");
      exit(1); }
  
  
  
  memset(zero_hw, 0, 6);
  memset(&sa, 0, sizeof(struct sockaddr_ll));
    
  interface_info(&sa);  
  
  printf("\nPAPS Passively Active Port Scanner v%s (C) willdamn\n\n", VERSION);
  printf("[X] Using %s\n", dev);  
  printf("[X] Discovery range: %d.%d.%d.%d - %d.%d.%d.%d\n", first[0], first[1], first[2], first[3], last[0], last[1], last[2], last[3]);

  
  query_eth_h=(struct ethhdr *)packet;
  memcpy(query_eth_h->h_dest, bcast_hw, ETH_ALEN);
  memcpy(query_eth_h->h_source, own_hw, ETH_ALEN);
  query_eth_h->h_proto=htons(ETH_P_ARP);
  

  query_arp_h=(struct arphdr *)(packet+14);
  query_arp_h->ar_hrd=htons(ARPHRD_ETHER);
  query_arp_h->ar_pro=htons(ETH_P_IP);
  query_arp_h->ar_hln=6;
  query_arp_h->ar_pln=4;
  query_arp_h->ar_op=htons(ARPOP_REQUEST);
  
  memcpy(query_arp_h->ar_sha, own_hw, ETH_ALEN);
  memcpy(query_arp_h->ar_sip, &own_ip, 4);
  memset(query_arp_h->ar_tha, 0, ETH_ALEN);
  
                    
  bottom_boundry = first[0]*254*254*254+first[1]*254*254+first[2]*254+first[3];
  top_boundry = last[0]*254*254*254+last[1]*254*254+last[2]*254+last[3];
  
  count = (last[0]*254*254*254+last[1]*254*254+last[2]*254+last[3]) - (first[0]*254*254*254+first[1]*254*254+first[2]*254+first[3]) +1;
  

  if((p_arp = pcap_open_live(dev, 40, 1, 1, errbuf))==NULL)
    {
      fprintf(stderr, "Cannot open device: %s\n", errbuf);
      exit(1);
    }

  set_arp_filter(p_arp);

  pfd=pcap_fileno(p_arp);

  FD_ZERO(&rfd);
  FD_SET(pfd, &rfd);

     for(a=first[0];a<=last[0];a++)       
         for(b=first[1];b<=last[1];b++)           
             for(c=first[2];c<=last[2];c++)              
                    for(d=first[3];d<=last[3];d++)
                      { 	
                         snprintf(addr, sizeof(addr), "%d.%d.%d.%d", a, b, c, d);     
                         inet_pton(PF_INET, addr, &query_arp_h->ar_tip);                	
  
                         if(sendto(sock, packet, sizeof(packet), 0, (struct sockaddr *)&sa, sizeof(sa))<0)
                             perror("sendto() ");         
                                                               
                         /* catch packet! */
                         
                         memset(&timeout, 0, sizeof(struct timeval));
                         timeout.tv_sec = 1;

                         while((select(pfd+1, &rfd, NULL, NULL, &timeout)>0))
    			   {

    			     pkt=(char *)pcap_next(p_arp, &hdr);
                             response_arp_h = (struct arphdr *)(pkt + sizeof(struct ethhdr));

                             sprintf(sip, "%d.%d.%d.%d", response_arp_h->ar_sip[0], response_arp_h->ar_sip[1],
                                                         response_arp_h->ar_sip[2], response_arp_h->ar_sip[3]);
                            
                             check = response_arp_h->ar_sip[0]*254*254*254 +
                                     response_arp_h->ar_sip[1]*254*254 +
                                     response_arp_h->ar_sip[2]*254 +
                                     response_arp_h->ar_sip[3];

                             if(!(check>=bottom_boundry && check <=top_boundry))
                                continue;

                             printf("\t [+] %s\n", sip);
                             new = list_elem(response_arp_h->ar_sha, sip);
                             list_add(&addr_list, new);

                             if(--count==0) break;

                             FD_SET(pfd, &rfd);
                           }
                          FD_SET(pfd, &rfd);
			}
  
  pcap_close(p_arp);        
  close(sock);
  
  list_arrange(&addr_list);
  list_sync(addr_list);
     
  printf("\n");  

}  


void get_mac(char *ip, char *hw)
{
  pcap_t *p;
  fd_set rfd;
  int pfd;
  struct pcap_pkthdr hdr;
  struct ethhdr *ethh;
  struct arphdr *arph;
  struct timeval timeout;
  unsigned char query[64], wanted_ip[4], *response;
  char errbuf[128];
  
  if((sock=socket(PF_PACKET, SOCK_RAW, 0))<0)
      { 
        perror("socket: ");
        exit(1); 
      }
      
  memset(zero_hw, 0, 6);
  memset(&sa, 0, sizeof(struct sockaddr_ll));

  interface_info(&sa);
      
  ethh=(struct ethhdr *)query;
  memcpy(ethh->h_dest, bcast_hw, ETH_ALEN);
  memcpy(ethh->h_source, own_hw, ETH_ALEN);
  ethh->h_proto=htons(ETH_P_ARP);
            
            
  arph=(struct arphdr *)(query+14);
  arph->ar_hrd=htons(ARPHRD_ETHER);
  arph->ar_pro=htons(ETH_P_IP);
  arph->ar_hln=6;
  arph->ar_pln=4;
  arph->ar_op=htons(ARPOP_REQUEST);          
  
  memcpy(arph->ar_sha, own_hw, ETH_ALEN);
  memcpy(arph->ar_sip, &own_ip, 4);
  memset(arph->ar_tha, 0, ETH_ALEN);
  
  inet_pton(PF_INET, ip, arph->ar_tip);
  inet_pton(PF_INET, ip, wanted_ip);


  if((p = pcap_open_live(dev, 40, 0, 0, errbuf))==NULL)
    {
      fprintf(stderr, "Cannot open device: %s\n", errbuf);
      exit(1);
    }

  set_arp_filter(p);
  
  if(sendto(sock, query, sizeof(query), 0, (struct sockaddr *)&sa, sizeof(sa))<0)
      perror("sendto: ");
  
  pfd = pcap_fileno(p); 
  
  FD_ZERO(&rfd);
  FD_SET(pfd, &rfd); 
  
  memset(&timeout, 0, sizeof(struct timeval));
  timeout.tv_sec = 1.5;
  
  if(select(pfd+1, &rfd, NULL, NULL, &timeout)<=0)
    {
      printf("Target is DOWN!\n");
      pcap_close(p);
      close(sock);
      exit(1);
    }
  
  if((response = (char *)pcap_next(p, &hdr)) == NULL)  
    {
      printf("%s\n", pcap_geterr(p));
      exit(1); 
    }
  
  memcpy(hw, response+22, 6);
                     
  pcap_close(p);
  close(sock);
}
         

void interface_info(struct sockaddr_ll *sa)
{
  struct ifreq ifr;
  int i, seed;
  
  /*
   * get some info about interface
   */
   
  if(dev==NULL)
    if((dev=pcap_lookupdev(NULL))==NULL)
       { fprintf(stderr, "Couldn't find any interface!\n");
         exit(1); }

  strncpy(ifr.ifr_name, dev, sizeof(ifr.ifr_name));

  if(!fake_ok)
    {
      if(ioctl(sock, SIOCGIFHWADDR, &ifr)<0)
          {
             perror("ioctl SIOCGIFHWADDR: ");
             exit(1);
          }

      memcpy(own_hw, ifr.ifr_hwaddr.sa_data, ETH_ALEN);

      if(ioctl(sock, SIOCGIFADDR, &ifr)<0)
          {
             perror("ioctl SIOCGIFADDR: ");
             exit(1);
          }
      memcpy((void *)&own_ip, ifr.ifr_addr.sa_data+2, 4);
    }
  else
    {
      read(rand_fd, &seed, sizeof(int));
      srand(seed);
      
      for(i=0;i<6;i++)
          own_hw[i] = rand();
              
      own_ip = rand();
    }
  
  strncpy(ifr.ifr_name, dev, sizeof(ifr.ifr_name));
  
  if(ioctl(sock, SIOCGIFINDEX, &ifr)<0)
    {
      perror("ioctl SIOCGIFINDEX");
      exit(1);
    }
      
  sa->sll_ifindex=ifr.ifr_ifindex;
  sa->sll_family=AF_INET;
  sa->sll_protocol=htons(ETH_P_ARP);
}

void set_arp_filter(pcap_t *p)
{
  int net, mask;
  struct bpf_program filter;
  char filter_app[10], errbuf[256];
  
  snprintf(filter_app, sizeof(filter_app), "arp[7]==2");
  
  if(pcap_lookupnet(dev, &net, &mask, errbuf)<0)
     { 
       fprintf(stderr, "%s\n", errbuf);
       exit(1); 
     }
              
  if(pcap_compile(p, &filter, filter_app, 0, net)<0)
     { 
       fprintf(stderr, "%s\n", pcap_geterr(p));
       exit(1); 
     }
                          
  if(pcap_setfilter(p, &filter)<0)
     { 
       fprintf(stderr, "Couldn't set filter\n");
       exit(1); 
     }
}
