#include "paps.h"

elem_t *
list_elem(unsigned char *hw, unsigned char *ip)
{
  elem_t *new;

  if((new = (elem_t *) malloc(sizeof(elem_t))) == NULL)
    { perror("malloc: ");
      exit(1); }
    
  memcpy(new->hw, hw, 6);
  memcpy(new->ip, ip, 16);

  return new;
}


void list_add(elem_t ** head, elem_t * new)
{
  elem_t *temp;
  
  temp = *head;
  while(temp!=NULL)
   { 
     if(strcmp(new->hw, temp->hw))
        break;
        
     temp=temp->next;
   }
              
  if(temp==NULL)
   {
     new->next = *head;
     *head = new;
   }                                                
}  

void list_del(elem_t **head, unsigned char *ip)
{
  elem_t *temp, *temp2;
  
  temp = *head;
  
  if(!strncmp(ip, temp->ip, sizeof(temp->ip)))
    { *head = temp->next;
       free(temp); 
       return; }
  
  while(temp!=NULL)
    {
      if(!strcmp(ip, temp->next->ip))
        break; 
      temp = temp->next;
    } 
  
  if(temp->next != NULL)
    {	
      temp2 = temp->next;
      temp->next = temp->next->next;
      free(temp2);
    }
}
      

  
void list_sync(elem_t * head)
{
  FILE *fd;
  elem_t *temp;
  

  if ((fd = fopen(FILE_PATH, "w+")) == NULL)
    {
      fprintf(stderr, "cannot open %s\n", FILE_PATH);
      exit(1);
    }

  temp = head;
  if (temp == NULL)
       {  
          fprintf(stderr, "[-] Couldn't catch any arp response, try later!\n");
          exit(1);
       }
       
  while (temp != 0)
    {
      fprintf(fd, "%s %.2x:%.2x:%.2x:%.2x:%.2x:%.2x\n", temp->ip,
	      temp->hw[0], temp->hw[1],
	      temp->hw[2], temp->hw[3], temp->hw[4], temp->hw[5]);
      temp = temp->next;
    }
  fclose(fd);
}

int
list_get(elem_t ** head)
{
  FILE *fd;
  elem_t *temp;
  int add, n = 0;
  int count, blind_hits, entry_count = 0;
  unsigned int buf[6];
  unsigned char hw[6];
  unsigned char ip[16];
  
  count = count_records();
  if(count > PTHREAD_MAX)
     blind_hits = count - PTHREAD_MAX;
  else
     blind_hits = 0;   
  
  if((fd = fopen(FILE_PATH, "r")) == NULL)
    return 0;
  

  for(n=0;n<count;n++)
    { 
      read(rand_fd, &add, sizeof(int)); add %= 2;
      
      fscanf(fd, "%s %x:%x:%x:%x:%x:%x\n", ip, &buf[0], &buf[1], &buf[2],
                                           &buf[3], &buf[4], &buf[5]);
      if(add || (blind_hits-- <= 0))
        {
          sprintf(hw, "%c%c%c%c%c%c", buf[0], buf[1], buf[2], buf[3], buf[4], buf[5]);
          temp = list_elem((char *)&hw[0], ip);
          list_add(head, temp);
          entry_count++;
        }
      
    }

  fclose(fd);
  
  return entry_count;
}

void list_arrange(elem_t **head)
{
  elem_t *temp1, *temp2;
  
  temp1 = *head;
  
  if(temp1 != NULL)
   while((temp1->next != NULL) && (temp1 != NULL))
     {   temp2=temp1->next;
         while(temp2 != NULL)
             if(!strcmp(temp1->ip, temp2->ip))
               list_del(&temp1->next, temp2->ip); 
             else
               temp2=temp2->next;
           
         temp1=temp1->next;
     }   
} 

         
       
int count_records(void)
{
  FILE *fd;
  int cnt = 0;
  char buf1[19], buf2[17];
  
  //XXX
        
  if((fd = fopen(FILE_PATH, "r")) == NULL)
    { fprintf(stderr, "[!] Map file dosen't exist\n");
      exit(1); }
  
  while(fscanf(fd, "%s %s\n", buf1, buf2) > 0)
     cnt++;
  
  fclose(fd);
  return cnt;
}

