/*
  
  paps - passively active port scanner
  _-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
  
  (C) Copyright 2006 by willdamn <willdamn@gmail.com>
  
*/

#include "paps.h"

#define COMP(a,b) ((a) > (b) ? (b) : (a))

struct pthread_arg *arg;

int main(int argc, char **argv)
{
  elem_t *temp;
  struct hostent *hostinfo;
  char *gateway_ip = NULL;
  char *port_range;
  int first[4], last[4];
  int *scan_type, tab[4] = { FIN_SCAN, XMAS_SCAN, NULL_SCAN, SYN_SCAN };
  int prefered_scan = SYN_SCAN;
  int n = 1, c, i, j = 0;
  
  
  if ((scan_type = (int *)malloc(PTHREAD_MAX*sizeof(int))) == NULL)
    { 
      fprintf(stderr, "Error: Couldn't allocate enough memory!\n");
      exit(1); 
    }
      
      
  time_for_port = 0.12;       
  dev = NULL; 
  
  /*
   * Provide a source of randomness
   */
        
  
  if((rand_fd = open(RAND_DEVICE, 0)) < 0)
    {   perror("Couldn't open the source of randomness: ");
        exit(1); }
  
  
  while ((c = getopt(argc, argv, "i:a:g:p:t:yhsfxnrSFXNUR")) > 0)
    {
      switch (c)
	{
	case 'h'  : { usage(argv[0]); }
	
	
	case 'i'  : {
	              dev = optarg;
                      break;
                    }

	case 'g'  : {
	              gateway_ip = optarg;
                      break;
                    }

	case 'a'  : {
	              compute_range(optarg, first, last);
                      arp_discovery(first, last);
                      exit(0);
                      break;
                    }

	case 'p'  : {
	              port_range=optarg;
                      break;
                    }

	case 'y'  : {
	              fake_ok = 1;
                      break;
                    }
                      
	case 't'  : {
	              time_for_port = atof(optarg);
	              break; 
                    }
                    
	case 's'  : { 
                      scan_type[j++] = SYN_SCAN;
                      break;
                    }

	case 'f'  : {
	              scan_type[j++] = FIN_SCAN;
                      break;
                    }

	case 'x'  : {
	              scan_type[j++] = XMAS_SCAN;
	              break;
                    }

	case 'n'  : { 
	              scan_type[j++] = NULL_SCAN;
                      break;
                    }

	case 'r'  : {
	              scan_type[j++] = RAND_SCAN;
                      break;
                    }

	case 'S'  : { 
	              prefered_scan = SYN_SCAN;
                      break;
                    }
                    
        case 'F'  : {
                      prefered_scan = FIN_SCAN;
                      break;
                    }
                    
        case 'X'  : {
                      prefered_scan = XMAS_SCAN;
                      break;
                    }
                    
        case 'N'  : {
                      prefered_scan = NULL_SCAN;
                      break;
                    }
                    
        case 'R'  : {
                      prefered_scan = RAND_SCAN;
                      break;
                    }
                    
	case 'U'  : { 
	              prefered_scan = UDP_SCAN; 
                      break;
                    }

	default   : {
	              usage(argv[0]);
                    }
	}
    }


  if (((argc - optind) == 0))// || (dev == NULL))
    usage(argv[0]);
  
  for (n = 0; n < PTHREAD_MAX; n++)
      scan_type[n] = prefered_scan;
    
  
  /*
   * service for some signals
   */
  
  signal(SIGINT, serve_polite);
  signal(SIGILL, serve_polite);
  signal(SIGHUP, serve_polite);
  signal(SIGABRT, serve_polite); 
  
  if(dev==NULL)
    if((dev=pcap_lookupdev(NULL))==NULL)
      { 
         fprintf(stderr, "Couldn't fine any interface!\n");
         exit(1);
      }

  printf("\nPAPS Passively Active Port Scanner v%s (C) willdamn\n\n", VERSION); 
  printf("[X] Using %s \n", dev);
  printf("[X] Target: %s\n", argv[optind]);
  
  printf("[*] Preparing...");
  fflush(stdout);
  
  if((hostinfo=gethostbyname(argv[optind])) == 0)
      { printf("Target is DOWN!\n");
        exit(1); }
  
  memcpy(&target, hostinfo->h_addr, sizeof(int));
  inet_ntop(PF_INET, &target, target_ip, sizeof(target_ip));
  
    
  pthread_count = list_get(&addr_list);
  if (pthread_count == 0)
    {
      printf("[!] At the begining you should get ip->mac map!\n");
      printf("[!] Launch with -a option\n");
      exit(1);
    }
  
      
  /*
   * if target's in the same segment, it's our gateway
   */
  
  memset(gateway, 0, sizeof(gateway));
   
  if(gateway_ip==NULL)
      gateway_ip = target_ip;
  
   
  temp = addr_list;
  while ((temp != NULL) && strcmp(gateway_ip, temp->ip))
      temp = temp->next;
        
  if (temp == NULL)
        get_mac(gateway_ip, gateway);
  else
     { 
        memcpy(gateway, temp->hw, ETH_ALEN);
    
    /* 
     *don't spoof gateway, 'cause you won't receive any response though
     */
      
        list_del(&addr_list, gateway_ip);
        pthread_count--;
     }
  
  
  
  if((arg = (struct pthread_arg *)calloc(pthread_count, sizeof(struct pthread_arg)))==NULL)
      { perror("calloc: ");
        exit(1); }
    
    
  if((ports = (struct port_list *)calloc(pthread_count, sizeof(struct port_list)))==NULL)
      {	perror("calloc: ");
        exit(1); }      
  
  if (j > pthread_count)
    printf("[!] Too many scan types, next time compute how many you really need\n");

  
  spread_ports(port_range);
  
  
  /*
   * Creating a couple of socks for using by threads
   */
   
  for(n = 0; n < SOCKS_COUNT; n++)
     if((socks[n]=socket(PF_PACKET, SOCK_RAW, 0)) < 0)
         { perror("socket: ");
           exit(1); }
                  
  
  printf("\n[*] You have to wait about %d sec\n", time_for_waiting);
    
  temp = addr_list;
  
  for (n = 0; n < pthread_count; n++)
    {
      if((ports[n].state = (int *)calloc(ports[n].count, sizeof(int)))==NULL)
          { perror("calloc ");
            exit(1); }
      
      inet_pton(PF_INET, temp->ip, &arg[n].decoy);
      arg[n].decoy_hw = temp->hw;
      arg[n].num = n;
      arg[n].scan_type = scan_type[n];

      if (scan_type[n] == RAND_SCAN)
	{
	  if ((ports[n].type=(int *)calloc(ports[n].count, sizeof(int)))==NULL)
              { perror("calloc: ");
                exit(1); }

	  for (i = 0; i < ports[n].count; i++)
	    ports[n].type[i] = tab[rand() % 4];  
	}
      

      pthread_create(&pthread_id[n], NULL, (void *)scan, (void *)&arg[n]);
      
      if ((temp = temp->next) == NULL)
	temp = addr_list;
    }
    
  free(scan_type);
    
  for (n = 0; n < pthread_count; n++)
      pthread_join(pthread_id[n], NULL);
  
  for(n = 0; n < SOCKS_COUNT; n++)
      close(socks[n]);
  
  close(rand_fd);
  
  display_results();
  
  return 0;
}


void scan(void *arg)
{
  struct pthread_arg *buf = (struct pthread_arg *)arg;
    
  switch (buf->scan_type)
    { 
      case UDP_SCAN :
          {
              udp_scan(buf->decoy_hw, buf->decoy, &ports[buf->num]);   
              break;
          }

      default :
          {
              tcp_scan(buf->decoy_hw, buf->decoy, buf->scan_type, &ports[buf->num]);
              break;
          }
    }
}



void compute_range(char *arg, int *first, int *last)
{
  char *ptr, *ptr0;
  int i;
  
  ptr0 = arg;
  ptr = arg;
  
  //XXX
  	
  for(i=0;i<3;i++)
      {	   
        if((ptr = strchr(ptr, '.'))==NULL)    
           { 
             fprintf(stderr, "[!] Bad address syntax\n");
             exit(1); 
           }
        *(ptr++)='\0'; 
        *(first+i) = atoi(ptr0);
        ptr0 = ptr;
      }
  
  if((ptr = strchr(ptr, '-'))==NULL)
    {
      fprintf(stderr, "[!] Bad address syntax\n");
      exit(1);
    } 
  
  *(ptr++)='\0';
  *(first+3) = atoi(ptr0);
  ptr0 = ptr;
  
  for(i=0;i<3;i++)
      {       
        if((ptr = strchr(ptr, '.'))==NULL)
            { 
              fprintf(stderr, "[!] Bad address syntax\n");
              exit(1);
            }
        *(ptr++)='\0'; 
        *(last+i) = atoi(ptr0);
        ptr0 = ptr;
      }                  
  *(last+3) = atoi(ptr0);                          
  
  if(first[3] >= 255)
    { first[3] = 1; (first[2]<255) ? first[2]++ : 0;
      if(first[2] >= 255)
        { first[2] >= 0; (first[1]<255) ? first[1]++ : 0;
          if(first[1] >= 255)
            { first[1] == 0; (first[0]<255) ? first[0]++ : 0; }
        }
    }
  
  if(first[0] == 255)
    {	fprintf(stderr, "[!] Bad port range\n");
        exit(1); }
        
}                                  
                 
      
int spread_ports(char *expr)
{
  char *ptr1, *ptr2;
  int fport, eport;
  int i, j, n; 
  int tmp, r1, r2;

  /*
   * ports' range 
   */
   
  ptr1 = expr;

  if ((ptr2 = strchr(expr, '-')) != NULL)
    {
      *(ptr2++) = '\0';

      fport = atoi(ptr1);
      eport = atoi(ptr2);
      
      if((eport-fport < 0) || (fport > 65535) || (eport > 65535))
        { 
          fprintf(stderr, "Error: Bad port range\n");
          exit(1);
        }
      
      for(i=0;i<pthread_count;i++)
          if((ports[i].port=(int *)calloc(((eport-fport+1)/pthread_count+1), sizeof(int)))==NULL)
              {	perror("calloc port");
                exit(1); }
      
      
      if(pthread_count > eport-fport+1) pthread_count=eport-fport+1;
      n=0;
      for (i = 0; i < eport - fport+1; i++)
	{ 
	  ports[n].port[i/pthread_count] = fport + i;
	  ports[n].count++;
	  if(++n==pthread_count) n=0;
        }

     n = eport - fport+1;
    
    }
  
  
  /*
   * list of ports
   */   
  
  else
    {
      ptr2 = expr;
      i = 1;
      while ((ptr1 = strchr(ptr2, ',')) != NULL)
        {
          ptr2 = ++ptr1;
          i++;
        }

      if (i > 65535)
        {
          i = 65535;
          printf("[!] Too many ports, right?...\n");
        }
      
      if(i<pthread_count) pthread_count=i;

  
      for(j=0;j<pthread_count;j++)
          if((ports[j].port=(int *)calloc(i/pthread_count+1, sizeof(int)))==NULL)
              { perror("calloc: ");
                exit(1); }
              
                                                       
      j=n=0;
  
      ptr2=expr;
      for(j=0;j<i;j++)
        {
          if((ptr1 = strchr(ptr2, ','))==NULL) break;
          *(ptr1++) = '\0';
          if((ports[n].port[j/pthread_count] = atoi(ptr2)) > 65535)
            {  fprintf(stderr, "Error: Bad port range\n");
               exit(1);  }
                              
          
          ports[n].count++;
          ptr2 = ptr1;
          if(++n==pthread_count) n=0;
        }

      ports[n].port[j/pthread_count] = atoi(ptr2);
      ports[n].count++;
  
      n = i;
   }
  
 
  j = 0;
  
  /*
   * Use only needed deals of addresses 
   */
  
  if(pthread_count > n) pthread_count = n;
  
  /*
   * Prompt about time user is made to wait
   */
  

  time_for_waiting = n * time_for_port+2;

  
  for (i = 0; i <= n; i++)
   { 
      read(rand_fd, &r1, sizeof(int)); r1 %= pthread_count; r1 = abs(r1);
      read(rand_fd, &r2, sizeof(int)); r2 %=(n/pthread_count); r2 = abs(r2);
      
      tmp = ports[j].port[COMP(i/pthread_count, ports[j].count-1)];
      ports[j].port[COMP(i/pthread_count, ports[j].count-1)] = ports[r1].port[COMP(r2, ports[j].count-1)];
      ports[r1].port[COMP(r2, ports[j].count-1)] = tmp;
      
      if(++j==pthread_count) j=0;
   }
  
                                                          
  return 0;
}

void display_results(void)
{
  int i, n;
  int is = 0;
  
  /*
   * Generaly don't write state of close and opene|filtered ports
   * If you need it, simply uncomment needed pieces of code
   */

  printf("\nPORT\t\t\tSTATE\n");
  for (i = 0; i < pthread_count; i++)
    {
      for (n = 0; n < ports[i].count; n++)
	{
	  switch((arg[i].scan_type == RAND_SCAN) ? ports[i].type[n] : arg[i].scan_type)
	    {
	       case SYN_SCAN :	{  	
	                                if(ports[i].state[n]==1)
	                                   { printf("%d/tcp\t\t\topen\n", ports[i].port[n]); 
	                                     is++; }
              //                         else if(ports[i].state[n]==0)
              //                              printf("%d/tcp\topen|filtered\n", ports[i].port[n]);
                                        break;  }
               
               case UDP_SCAN :	{
                                        if(ports[i].state[n]==2)
                                           { printf("%d/udp\t\t\topen\n", ports[i].port[n]);
                                             is++; }	
              //                          else if(ports[i].state[n]==0)
              //                            { printf("state %d\t%d/udp\t\t\topen|filtered\n", ports[i].state[n], ports[i].port[n]);
              //                               is++; }
                                        break;  }
               
               default	     :	{       if(ports[i].state[n]!=1)
                                           { printf("%d/tcp\t\t\topen|filtered\n", ports[i].port[n]);  
                                             is++; }
                                        break;  }
	    }                             
        }
    }
 if(!is)
   { printf("[!] Unfortunately there are no open ports in target machine\n");
     printf("[!] Try again, maby some problems on the wire\n"); }
 printf("\n");    
}



void serve_polite(int sig)
{
  display_results();
  printf("+++Exiting on signal %d+++\n", sig);
  exit(1);
} 


void usage(char *path)
{ 
  fprintf(stderr, "PAPS Passively Active Port Scanner v%s (C) willdamn\n", VERSION);
  fprintf(stderr, "%s: usage [options] host\n", path);
  fprintf(stderr, "\t-S -s \t\t syn scan (default method)\n");
  fprintf(stderr, "\t-F -f \t\t fin scan\n");
  fprintf(stderr, "\t-X -x \t\t Xmas scan\n");
  fprintf(stderr, "\t-N -n \t\t NULL scan\n");
  fprintf(stderr, "\t-R -r \t\t random scan (each port scan by randomly method)\n");
  fprintf(stderr, "\t-U  \t\t udp scan\n");
  fprintf(stderr, "\t-a <host range>  create ip->mac map\n");
  fprintf(stderr, "\t-p <ports> \t ports you wanna scan\n");
  fprintf(stderr, "\t-g <ip> \t gateway ip\n");
  fprintf(stderr, "\t-t <val>\t time for waiting for each port (default 0.1 sec)\n");
  fprintf(stderr, "\t-y \t\t fake mac and ip during creating map\n");
  fprintf(stderr, "\t-i <interface> \t interface\n");
  fprintf(stderr, "\t-h \t\t display me\n");
  exit(1);
}

