#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/ip.h>
#include <netdb.h>
#define __FAVOR_BSD 1
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <linux/if_ether.h>
#include <linux/if.h>
#include <linux/if_packet.h>
#include <fcntl.h>
#include <signal.h>
#include <pthread.h>
#include <pcap.h>

#define VERSION "1.2"
#define RAND_DEVICE "/dev/urandom"
#define FILE_PATH "/etc/addrmap"             
#define PTHREAD_MAX 256
#define SOCKS_COUNT 4
#define TH_PSH 0x08

#define NULL_SCAN	0
#define SYN_SCAN	TH_SYN
#define FIN_SCAN	TH_FIN
#define XMAS_SCAN	TH_FIN|TH_URG|TH_PSH
#define UDP_SCAN	4
#define RAND_SCAN	7


/*
 * from net/if_arp.h
 */

#define ARPHRD_ETHER    1
#define ARPOP_REQUEST   1
#define ARPOP_REPLY     2

struct arphdr
{
        unsigned short  ar_hrd;         /* format of hardware address   */
        unsigned short  ar_pro;         /* format of protocol address   */
        unsigned char   ar_hln;         /* length of hardware address   */
        unsigned char   ar_pln;         /* length of protocol address   */
        unsigned short  ar_op;          /* ARP opcode (command)         */

        unsigned char           ar_sha[ETH_ALEN];       /* sender hardwareaddress      */
        unsigned char           ar_sip[4];              /* sender IP address*/
        unsigned char           ar_tha[ETH_ALEN];       /* target hardware address      */
        unsigned char           ar_tip[4];              /* target IP address */
};


struct port_list {
      int *port;
      int *state;		
      int *type;
      int count;
};

typedef struct elem{
      unsigned char hw[ETH_ALEN];
      unsigned char ip[16];                     // dotting ip
      int sync;
      struct elem *next;
}elem_t;

struct pthread_arg
{
  unsigned char *decoy_hw;
  int decoy;
  int scan_type;
  int num;
};
          


 typedef unsigned short u_16;
 typedef unsigned int u_32;

/*
 * globals
 */
 pthread_t pthread_id[PTHREAD_MAX];
 struct port_list *ports;
 elem_t *addr_list;
 unsigned char gateway[ETH_ALEN];
 char net_ebuf[100], pcap_ebuf[PCAP_ERRBUF_SIZE];
 char *dev;
 char target_ip[16]; 
 int target;
 double time_for_port;
 int pthread_count, time_for_waiting;
 int first_host, last_host, fake_ok;
 int rand_fd, socks[SOCKS_COUNT];

/*
 * discovery function
 */
 void arp_discovery(int *first, int *last);
 void get_mac(char *ip, char *hw);
 void set_arp_filter(pcap_t *p);

/*
 * list functions
 */ 
 elem_t *list_elem(unsigned char *hw, unsigned char *ip);
 void list_add(elem_t ** head, elem_t * new);
 void list_del(elem_t **head, unsigned char *ip);
 void list_sync(elem_t * head);
 int list_get(elem_t ** head);
 void list_arrange(elem_t **head);
 void list_reduce(elem_t **head, int cnt);
 
/*
 * scanning functions
 */
 void tcp_scan(unsigned char *decoy_hw, int decoy, int scan_type, struct port_list *ports);
 int tcp_sender(unsigned char *decoy_hw, int decoy, int scan_type, struct port_list *ports);
 void udp_scan(unsigned char *decoy_hw, int decoy, struct port_list *ports);
 int udp_sender(unsigned char *decoy_hw, int decoy, struct port_list *ports);

/*
 * miscellaneous functions
 */
 void scan(void *arg);
 unsigned short in_cksum(u_16 *ptr,int nbytes);
 void interface_info(struct sockaddr_ll *sa);
 int spread_ports(char *expr);
 void compute_range(char *arg, int *first, int *last);
 void display_results(void);
 void print_error(char *msg);
 void usage(char *path);
 void serve_polite(int sig);
 int count_records(void);
